/* this file holds all the effect programs  for Sphgere II*/
#include "PixelFunctions.h"
/**
*
* FADE Neightbours
*
**/

#define PALETTE_OFFSET       48
#define FADE_AMOUNT          20
#define LEFT_FADE_AMOUNT     FADE_AMOUNT
#define RIGHT_FADE_AMOUNT    FADE_AMOUNT

int fadeNeighbours(unsigned long now, void * userData)
{
  static uint8_t paletteIndex = 0;
  static unsigned long lastNow = 0;
  if(effectStarted){
    effectStarted = false;
    fill_solid(leds,NUM_LEDS,CRGB::Black);
    for(uint8_t i=0;i<6;i++){
           uint8_t pix = LEDForPosInBand(0,i);
       CRGB cColor = ColorFromPalette(colorPalettes[currentPalette],paletteIndex+i*PALETTE_OFFSET);
       leds[pix]=cColor;
    }
//    fill_rainbow(leds,NUM_LEDS,ColorFromPalette(colorPalettes[currentPalette],paletteIndex));
  //fillBand(0,CRGB::Red);
//    leds[0]=CRGB::Red;
  }else{
    for(uint8_t cBand = 1;cBand< 5;cBand++){
      uint8_t ledsInBand = bands[cBand].pixelsInBand;
      for(uint8_t pixel=0;pixel<ledsInBand;pixel++){
        uint8_t pix = LEDForPosInBand(cBand,pixel);
        CRGB cColor = leds[pix];
        neightbours_t nb = neightbours[pix];
        uint8_t nPix ;
        CRGB nbColor;
        #if DEBUG_EFFECTS
        Serial<<"ID: "<<pixel<<" ("<<cBand<<") ";
        #endif
        // THE BOTTOM NEightbours
#if 1
        if(nb.bottomLeftNeightbour >=0){
          #if DEBUG_EFFECTS
          Serial<<"bottomLeft "<<nb.bottomLeftNeightbour<<" -";
          #endif
          nPix = LEDForPosInBand(cBand-1 ,nb.bottomLeftNeightbour);
          nbColor=leds[nPix];
          nblend(cColor,nbColor,LEFT_FADE_AMOUNT);
        }
#endif

#if 1
        if(nb.bottomCenterNeightbour >=0){
          #if DEBUG_EFFECTS
          Serial<<"bottomCenter ";
          #endif
          nPix = LEDForPosInBand(cBand-1,nb.bottomCenterNeightbour);
          nbColor=leds[nPix];
          nblend(cColor,nbColor,FADE_AMOUNT);
        }
#endif

#if 1
        if(nb.bottomRightNeightbour >=0){
          #if DEBUG_EFFECTS
          Serial<<"bottomRight ";
          #endif

          nPix = LEDForPosInBand(cBand-1,nb.bottomRightNeightbour);
          nbColor=leds[nPix];
          nblend(cColor,nbColor,RIGHT_FADE_AMOUNT);

        }
#endif
        // the direct Neighbours
#if 0
        { // left
          int8_t lPix = pixel -1;
          if(lPix<0){
            lPix=ledsInBand -1;
          }
          nPix = LEDForPosInBand(cBand,nPix);
          nbColor=leds[nPix];
          nblend(cColor,nbColor,LEFT_FADE_AMOUNT/2);
        }
        { // right
          int8_t lPix = pixel +1;
          if(lPix>=ledsInBand){
            lPix=0;
          }
          nPix = LEDForPosInBand(cBand,nPix);
          nbColor=leds[nPix];
          nblend(cColor,nbColor,RIGHT_FADE_AMOUNT/2);
        }
#endif
        #if DEBUG_EFFECTS
        Serial<<endl;
        #endif
       leds[pix]=cColor;
      }
    }

    // Rotate the initial pixels
    if( (now - lastNow) > currentDelay*2){
      for(uint8_t i=0;i<6;i++){
        uint8_t pix = LEDForPosInBand(0,i);
        CRGB cColor = ColorFromPalette(colorPalettes[currentPalette],paletteIndex+i*PALETTE_OFFSET);
        leds[pix]=cColor;
      }
      lastNow = now;
      paletteIndex+=1;

    }
  }
  FastLED.show();
}

/**
*
* RUNNING Dots
*
**/

int runningDots(unsigned long now, void* userData)
{
  static uint8_t paletteEntry = 0;
  static uint8_t pixelPos=0;
  static uint8_t smallPixelPos = 0;
  uint8_t pixels = 8;
  uint8_t smallPixels = 6;

  uint8_t paletteSection = 256/5;
  //  ColorFromPalette(colorPalettes[currentPalette],j+i*segment,255);
  CRGB background;
  if(effectStarted){
    effectStarted = false;
    background = CRGB::Black;
    fill_solid(leds,NUM_LEDS,background);
  }else{
    background = ColorFromPalette(colorPalettes[currentPalette],paletteEntry+0*paletteSection,255);//CRGB::Black;
  }
  CRGB band0Color = ColorFromPalette(colorPalettes[currentPalette],paletteEntry+1*paletteSection,255);//CRGB::Red;
  CRGB band1Color = ColorFromPalette(colorPalettes[currentPalette],paletteEntry+2*paletteSection,255);//CRGB::Blue;
  CRGB band2Color = ColorFromPalette(colorPalettes[currentPalette],paletteEntry+3*paletteSection,255);//CRGB::Orange;
  CRGB band3Color = ColorFromPalette(colorPalettes[currentPalette],paletteEntry+4*paletteSection,255);//CRGB::Green;
  //  band2Color = CRGB::Orange;
  fract8 fIn = 12;
  fract8 fOut = 8;
  static int16_t itterations = 0;

  uint8_t alternatePixelPos = (pixels - pixelPos);
  uint8_t smallAlternatePixelPos = (smallPixels - smallPixelPos);
  leds[NUM_LEDS-1]=background;
  runPixelInBand(0,background,band0Color,smallAlternatePixelPos,3,fIn,fOut,true);
  runPixelInBand(2,background,band2Color,alternatePixelPos,4,fIn,fOut,true);
  runPixelInBand(1,background,band1Color,pixelPos,4,fIn,fOut,false);
  runPixelInBand(3,background,band3Color,smallPixelPos,3,fIn,fOut,false);

  if(itterations++ > 1.0/fIn*256){
    #if DEBUG_EFFECTS
    Serial <<" iter: "<<itterations<<endl;
    #endif
    itterations=0;
    pixelPos=++pixelPos%pixels;
    smallPixelPos = ++smallPixelPos % smallPixels;
  }
  if(!itterations % 3){
  paletteEntry++;// = ++paletteEntry%paletteSection;
  }
  FastLED.show();

}

/**
*
* Rainbow Bands
*
**/

int rainbowBands(unsigned long now,void* userData)
{
//	Serial <<"RainbowBands"<<(long int) userData<<endl;
  static uint8_t j = 0;
  boolean runWhiteDot = false;
  uint8_t i;
  uint16_t segment;
  //if(NULL!=userData)
//    segment  = *((int16_t*)userData);
//   else
    segment = 255/5;
  if(segment > 255){
    runWhiteDot = true;
  }
  segment &=0xff;

  for(i=0; i<=5; i++) {
#if USE_PALETTES
    CRGB t = ColorFromPalette(colorPalettes[currentPalette],j+i*segment,255);
#else
    CRGB t = CHSV(j+i*segment,255,255);
#endif
    fillBand(5-i,t);
  }
  j++;
//  whiteRunningDott(now,NULL);
  FastLED.show();

}

/**
*
* Rainbow Spiral
*
**/

int rainbowSpiral(unsigned long now,void* userData)
{
   static uint8_t j = 0;
  uint8_t i;
  uint8_t segment = 255/NUM_LEDS;
    for(i=0; i<NUM_LEDS; i++) {
#if USE_PALETTES
    CRGB t = ColorFromPalette(colorPalettes[currentPalette],j+i*segment);
#else
      CRGB t = CHSV(j+i*segment,255,255);
#endif
      leds[i] = t;
    }
    j++;
  FastLED.show();

}


/**
*
* Fire
*
**/

#define COOLING  55
#define SPARKING 120
int Fire2012(unsigned long now, void* userData)
{
// Array of temperature readings at each simulation cell
  static byte heat[NUM_LEDS];

  // Step 1.  Cool down every cell a little
    for( int i = 0; i < NUM_LEDS; i++) {
      heat[i] = qsub8( heat[i],  random8(0, ((COOLING * 10) / NUM_LEDS) + 2));
    }

    // Step 2.  Heat from each cell drifts 'up' and diffuses a little
    for( int k= NUM_LEDS - 1; k >= 2; k--) {
      heat[k] = (heat[k - 1] + heat[k - 2] + heat[k - 2] ) / 3;
    }

    // Step 3.  Randomly ignite new 'sparks' of heat near the bottom
    if( random8() < SPARKING ) {
      int y = random8(7);
      heat[y] = qadd8( heat[y], random8(160,255) );
    }

    // Step 4.  Map from heat cells to LED colors
    for( int j = 0; j < NUM_LEDS; j++) {
#if USE_PALETTES
    CRGB t = ColorFromPalette(colorPalettes[currentPalette],heat[j]);
    leds[j]=t;
#else
        leds[j] = HeatColor( heat[j]);
#endif
    }
    FastLED.show();

}
